
/*
   Time library
   
   last modified 
   30.09.2005
   20.04.2005
   created 13.04.2005

samples:
   int period       = get_period_by_str("MN1")
   int period_value = get_period_value(shift, period)
   int shift        = goto_one_period_back(int shift, int period)
   
   double open, high, low, close;
   ohlc(0,PERIOD_D1, 1, open, high, low, close);
   Print("Open is ", DoubleToStr(open, Digits()), " High is ", DoubleToStr(high,Digits())," Low is ", DoubleToStr(low,Digits()), " Close is ", DoubleToStr(close,Digits()) );
   
*/


// ****
//    -
int get_period_value(int shift, int period_)
{
  int d;
  switch(period_)
  {
    case 5:  d = MathCeil( TimeMinute(Time[shift])/5); break;
    case 15: d = MathCeil( TimeMinute(Time[shift])/15); break;
    case 30: d = MathCeil( TimeMinute(Time[shift])/30); break;
    case 60: d = TimeHour(Time[shift]); break;
    case 240: d = MathCeil(TimeHour(Time[shift])/4);break;
    case 1440: d = TimeDay(Time[shift]); break;
    case 10080: 
      int w_shift = shift; //     ;)
      while ( (w_shift < (Bars-1)-2) && ( TimeDayOfWeek(Time[w_shift+1]) <= TimeDayOfWeek(Time[w_shift]) ) ) 
      { w_shift = w_shift + 1; }
      d = TimeDay(Time[w_shift]); 
      break;
    case 43200: d = TimeMonth(Time[shift]); break;
    case 518400: d = TimeYear(Time[shift]);break;
  }
  return(d);
}



// ****
//    
int get_period_by_str(string s)
{
   int p = 0;
   
   if (s == "M5")  { p = 5; }
   else 
   if (s == "M15") { p = 15; }
   else 
   if (s == "M30") { p = 30; }
   else 
   if (s == "H1")  { p = 60; }
   else
   if (s == "H4")  { p = 240; }
   else
   if (s == "D1")  { p = 1440; }
   else
   if (s == "W1")  { p = 10080; }
   else
   if (s == "MN1") { p = 43200; }
   else
   if (s == "Y1")  { p = 518400; }
   return(p);
}


int goto_one_period_back(int shift, int period)
{
   int now = get_period_value(shift, period);
   while( now == get_period_value(shift,period) )
   {
     shift = shift + 1;
   }
   return(shift);
}


int get_period(int shift)
{
   int period_;
   if (Period() == 1440)
   {
     //  -     (     = 3 )
     period_ = MathMin( Time[shift] - Time[shift+1], Time[shift+1] - Time[shift+2]);
     //Comment(period_);
   }
   else
   {
     period_ = MathMax( Time[shift] - Time[shift+1], Time[shift+1] - Time[shift+2]);
   }   
   return(period_);
}


void ohlc(int shift, int period_, int period_skip, double& open, double& high, double& low, double& close, int& high_shift, int& low_shift)
{
   //int shift = 0;
   for(int n = 0; n < period_skip; n++)
   {
     shift = goto_one_period_back(shift, period_);
   }
   
   int current_period = get_period_value(shift, period_);
   high = High[shift];
   high_shift = shift;
   low = Low[shift];
   low_shift = shift;
   open = Open[shift];
   close = Close[shift];

   while((get_period_value(shift, period_)==current_period)&&(shift < Bars-1))
   {
     if(High[shift] > high)
     {
       high = High[shift];
       high_shift = shift;
     }
     if(Low[shift] < low)
     {
       low = Low[shift];
       low_shift = shift;
     }
     open = Open[shift];
     shift = shift + 1;
   }
}


