#property copyright "Anisa Pramelda"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Gold
#property indicator_color2 Lime
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Purple
#property indicator_color6 Brown
#property indicator_color7 Pink
#property indicator_color8 Aqua
extern string newyork = "40.5N 74W";
extern string tokyo = "35.40N 139.45E";
extern string london = "51.32N 0.5W";
extern double latitude = 40.5;
extern double longitude = -74;
extern int prec = 2;
extern bool cmb1 = true;
extern int  pl1a = 0;
extern int  pl1b = 1;
double dg0,dg1,dg2,dg3,dg4,dg5,dg6,dg7,dg8;
extern int    iflag = 0;
extern int    FutureBars=200;
extern int    BarsLimit=10000;

extern int Period_ = 1;


int period_ = 0;
double past_longtitude = -1;


#include <astro_swiss.mq4>
#include <astro_func.mq4>
#include <time.mq4>

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   string short_name = "PLine";
   if(Period_ > 1)
   {
     short_name = short_name + " " + DoubleToStr(Period_,0) + " periods";
   }
   IndicatorShortName(short_name);
   SetIndexLabel(0,"cmb1");   
   SetIndexStyle(0,DRAW_ARROW,0,1);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexShift(0,FutureBars);
   SetIndexLabel(1,"cmb2");   
   SetIndexStyle(1,DRAW_ARROW,0,1);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexShift(1,FutureBars);
   SetIndexLabel(2,"cmb3");   
   SetIndexStyle(2,DRAW_ARROW,0,1);
   SetIndexArrow(2,159);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexShift(2,FutureBars);
   SetIndexLabel(3,"cmb4");   
   SetIndexStyle(3,DRAW_ARROW,0,1);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexShift(3,FutureBars);
   SetIndexLabel(4,"cmb5");   
   SetIndexStyle(4,DRAW_ARROW,0,1);
   SetIndexArrow(4,159);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexShift(4,FutureBars);
   SetIndexLabel(5,"cmb6");   
   SetIndexStyle(5,DRAW_ARROW,0,1);
   SetIndexArrow(5,159);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexShift(5,FutureBars);
   SetIndexLabel(6,"cmb7");   
   SetIndexStyle(6,DRAW_ARROW,0,1);
   SetIndexArrow(6,159);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexShift(6,FutureBars);
   SetIndexLabel(7,"cmb8");   
   SetIndexStyle(7,DRAW_ARROW,0,1);
   SetIndexArrow(7,159);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexShift(7,FutureBars);
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   int limit;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   int shift = limit - FutureBars;
   if (shift < 0)
   {
     return(0);
   }
//---- TODO: add your code here
dg0=High[iHighest(NULL,0,MODE_CLOSE,WHOLE_ARRAY,0)];   
dg1=Low[iLowest(NULL,0,MODE_CLOSE,WHOLE_ARRAY,0)];
dg8=dg1+(dg0-dg1)*7/10;
dg7=dg1+(dg0-dg1)*6/10;
dg6=dg1+(dg0-dg1)*5/10;
dg5=dg1+(dg0-dg1)*4/10;
dg4=dg1+(dg0-dg1)*3/10;
dg3=dg1+(dg0-dg1)*2/10;
dg2=dg1+(dg0-dg1)*1/10;
   // topo
   //spb astro_swe_set_topo(53,50,0);
   // new york
   // 40.5 N 74W
   astro_swe_set_topo(latitude,longitude,0);
   
   
   
   // Draw Normal
   //
   if (shift > BarsLimit)
   {
     shift = BarsLimit;
   }
   int ctr=0;
   double v1;
   while ( shift > 0 )
   {
    v1 = get_astro_value(Time[shift],pl1a,pl1b);
    ExtMapBuffer1[shift+FutureBars]=NormalizeDouble(dg1+v1*Point*prec,Digits);
    ExtMapBuffer2[shift+FutureBars]=NormalizeDouble(dg2+v1*Point*prec,Digits);
    ExtMapBuffer3[shift+FutureBars]=NormalizeDouble(dg3+v1*Point*prec,Digits);
    ExtMapBuffer4[shift+FutureBars]=NormalizeDouble(dg4+v1*Point*prec,Digits);
    ExtMapBuffer5[shift+FutureBars]=NormalizeDouble(dg5+v1*Point*prec,Digits);
    ExtMapBuffer6[shift+FutureBars]=NormalizeDouble(dg6+v1*Point*prec,Digits);
    ExtMapBuffer7[shift+FutureBars]=NormalizeDouble(dg7+v1*Point*prec,Digits);
    ExtMapBuffer8[shift+FutureBars]=NormalizeDouble(dg8+v1*Point*prec,Digits);
    shift = shift - 1;
   }
 
   // Draw Future
   // now shift = 0
   datetime curr_datetime = Time[shift];
   int period_ = get_period(shift);
   while ( shift > -FutureBars )
   {
    v1 = get_astro_value(curr_datetime,pl1a,pl1b);
    ExtMapBuffer1[shift+FutureBars]=NormalizeDouble(dg1+v1*Point*prec,Digits);
    ExtMapBuffer2[shift+FutureBars]=NormalizeDouble(dg2+v1*Point*prec,Digits);
    ExtMapBuffer3[shift+FutureBars]=NormalizeDouble(dg3+v1*Point*prec,Digits);
    ExtMapBuffer4[shift+FutureBars]=NormalizeDouble(dg4+v1*Point*prec,Digits);
    ExtMapBuffer5[shift+FutureBars]=NormalizeDouble(dg5+v1*Point*prec,Digits);
    ExtMapBuffer6[shift+FutureBars]=NormalizeDouble(dg6+v1*Point*prec,Digits);
    ExtMapBuffer7[shift+FutureBars]=NormalizeDouble(dg7+v1*Point*prec,Digits);
    ExtMapBuffer8[shift+FutureBars]=NormalizeDouble(dg8+v1*Point*prec,Digits);
     shift = shift - 1;
     curr_datetime = curr_datetime + period_;
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

double get_astro_value(datetime d,int Body, int Body2)
{
   double longtitude, latitude;
   double longtitude2, latitude2;
   double distance, distance2;
   double speed;

   astro_swe_calc(d, Body, iflag, longtitude, latitude, distance, speed);
   astro_swe_calc(d, Body2, iflag, longtitude2, latitude2, distance2, speed);
   return(func_P(longtitude,longtitude2));
}


